#!/etc/opt/openit/perl -w

use strict;

my $cfg = "/var/opt/openit/etc/daft.conf";
my $old = "/var/opt/openit/etc/daft.conf.old";
my $new = "/var/opt/openit/etc/daft.conf.new";

open(OUT, ">$new") || die "Error: Can't write new cfg '$new'!\n";
open(IN, "$cfg") || die "Error: Unable to read old cfg '$cfg'!\n";

# Copy all up to filtrate object
my $line;
while($line = <IN>) {
    print OUT $line;
    if($line =~ /filtrate\(\)=/) {
	last;
    }
}

# Also keep next line ({)
$line = <IN>; print OUT $line;

# Now read filtre lines to convert
while($line = <IN>) {
    if ($line =~ /^\s*}\s*$/) {
	print OUT $line;
	last
    }
    if ($line =~ /\$BEG \$END/) { # Already updated
	print OUT $line;
    } else {
	my $new_seq;

	$line =~ /^(\s*)(.*)\(String\)="(.*)"\{\}\s*$/;
	my $space = $1;
	my $archtype = $2;
	foreach my $def (split(",", $3)) {
	    my ($filter, $period) = split(":", $def);
	    if (! defined($new_seq)) {
		$new_seq = "$filter \$BEG \$END $period";
	    } else {
		$new_seq .= ",$filter \$BEG \$END $period";
	    }
	}

	print OUT "${space}${archtype}(String)=\"${new_seq}\"\{\}\n";
    }
}

# Keep rest of lines
while($line = <IN>) {
    print OUT $line;
}

close(IN);
close(OUT);

if( ! rename($cfg, $old)) {
    die "Error: Unable to previous config to '$old'!\n";
}

if( ! rename($new, $cfg)) {
    die "Error: Unable to rename new config to '$cfg'!\n";
}

exit 0;
